//
//  View.m
//  Nest
//
//  Created by NYU User on 11/8/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "View.h"
#import "Animatee.h"


@implementation View


- (id) initWithFrame: (CGRect) frame {
	if ((self = [super initWithFrame: frame])  != nil) {
		// Initialization code
		self.backgroundColor = [UIColor whiteColor];
		
		CGSize s = CGSizeMake(50, 50);
		CGRect f = CGRectMake(
			(self.bounds.size.width - s.width) / 2,
			(self.bounds.size.height - s.height) / 2,
			s.width,
			s.height
		);
				
		animatee = [[Animatee alloc] initWithFrame: f];
		animatee.alpha = 0;
		[self addSubview: animatee];
	}
	return self;
}

- (void) blocksFrom: (int) i {
	typedef void (^AnimationBlock)(void);
	AnimationBlock block;
	const NSUInteger n = 2 * 6;	//number of animation blocks: 5 pairs
	
	if (i == 0) {
		block = ^{
			//Fade in.
			animatee.alpha = 1;
		};
	}
	
	else if (i == 1) {
		block = ^{
			animatee.transform = CGAffineTransformMakeScale(2, 1);
		};
	}
	
	else if (i == 2) {
		block = ^{
			animatee.transform = CGAffineTransformMakeScale(2, 2);
		};
	}
	
	else if (i == 3) {
		block = ^{
			animatee.transform = CGAffineTransformRotate(animatee.transform, -45 * M_PI / 180);
		};
	}
	
	else if (i == 4) {
		block = ^{
			animatee.transform = CGAffineTransformTranslate(animatee.transform, -20, -20);
		};
	}
	
	else if (i == 5) {
		block = ^{
			animatee.backgroundColor = [UIColor redColor];
		};
	}
	
	else if (i == 6) {
		block = ^{
			animatee.backgroundColor = [UIColor blackColor];
		};
	}
	
	else if (i == 7) {
		block = ^{
			//Undo the translation.
			animatee.transform = CGAffineTransformTranslate(animatee.transform, 20, 20);
		};
	}
	
	else if (i == 8) {
		block = ^{
			//Undo the rotation.
			animatee.transform = CGAffineTransformMakeScale(2, 2);
		};
	}
	
	else if (i == 9) {
		block = ^{
			//Undo the scale.
			animatee.transform = CGAffineTransformMakeScale(2, 1);
		};
	}

	else if (i == 10) {
		block = ^{
			//Undo the scale.
			animatee.transform = CGAffineTransformMakeScale(1, 1);
		};
	}
	
	
	else if (i == 11) {
		block = ^{
			//Undo the fade-in.
			animatee.alpha = 0;
		};
	}
	
	else {
		return;
	}
	
	[UIView animateWithDuration: 1.5
		delay: 0
		options: UIViewAnimationOptionCurveEaseInOut 
		animations: block
		completion: ^(BOOL b) {
			if (b && i < n) {
				[self blocksFrom: i + 1];
			}
		}
	];
}

// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void) drawRect: (CGRect) rect {
	// Drawing code
	[self blocksFrom: 0];
}


- (void) dealloc {
	[animatee release];
	[super dealloc];
}


@end
